<?php
/*
Plugin Name: Zstore Helper
Plugin URI: http://return-true.com/
Description: Makes it easy to install & use the zstore builder provided by Zazzle.com.
Version: 1.5
Author: Paul Robinson
Author URI: http://return-true.com

	Copyright (c) 2008 - 2010 Paul Robinson (http://return-true.com)
	Zstore Helper is released under the GNU General Public License (GPL)
	http://www.gnu.org/licenses/gpl.txt

	This is a WordPress plugin (http://wordpress.org).
	Plugin code is owned by me.
*/

// First let's make an options page.
register_activation_hook(__FILE__, 'zstore_activate');
register_deactivation_hook(__FILE__, 'zstore_deactivate');
add_action('admin_menu', 'zstore_add_options');
add_action('wp_head', 'zstore_add_css');
add_shortcode('zstore', 'zstore_helper_shortcode');

function zstore_activate() {
	
	$defaults = array('contributorHandle' => '',
					  'associateId' => 'YOURASSOCIATEIDHERE',
					  'productLineId' => '',
					  'productType' => '',
					  'keywords' => '',
					  'gridWidth' => '700',
					  'gridCellSize' => 'medium',
					  'gridCellSpacing' => '5',
					  'gridCellBgColor' => 'FFFFFF',
					  'useAnalytics' => 'false',
					  'analyticsId' => '',
					  'showHowMany' => '20',
					  'startPage' => '1',
					  'showPagination' => true,
					  'showSorting' => true,
					  'defaultSort' => 'date_created',
					  'showProductDescription' => true,
					  'showByLine' => true,
					  'showProductTitle' => true,
					  'showProductPrice' => true,
					  'useCaching' => false,
					  'cacheLifetime' => '7200');
					  
	if(get_option( 'zstore_options' ) == false) {
		update_option( 'zstore_options', $defaults );
	}
	
}

function zstore_deactivate() {
	
	delete_option( 'zstore_options' );
	
}

function zstore_add_options() {
	//Old WP MU Compat
	if( function_exists( 'is_multisite' ) ) {
		if( is_multisite() ) {
			//add_submenu_page('wpmu-admin.php', __('Zstore Helper'), __('Zstore Helper'), 'manage_options', __FILE__, 'zstore_options_page');
			add_options_page('Zstore Helper', 'Zstore Helper', 'manage_options', __FILE__, 'zstore_options_page');
		} else {
			add_options_page('Zstore Helper', 'Zstore Helper', 'manage_options', __FILE__, 'zstore_options_page');
		}
	} else {
		add_options_page('Zstore Helper', 'Zstore Helper', 'manage_options', __FILE__, 'zstore_options_page');
	}
}

function zstore_options_page() {
	

    $opt_name = array('contributorHandle' => 'contributorHandle',
					  'associateId' => 'associateId',
					  'productLineId' => 'productLineId',
					  'productType' => 'productType',
					  'keywords' => 'keywords',
					  'gridWidth' => 'gridWidth',
					  'gridCellSize' => 'gridCellSize',
					  'gridCellSpacing' => 'gridCellSpacing',
					  'gridCellBgColor' => 'gridCellBgColor',
					  'useAnalytics' => 'useAnalytics',
					  'analyticsId' => 'analyticsId',
					  'showHowMany' => 'showHowMany',
					  'startPage' => 'startPage',
					  'showPagination' => 'showPagination',
					  'showSorting' => 'showSorting',
					  'defaultSort' => 'defaultSort',
					  'showProductDescription' => 'showProductDescription',
					  'showByLine' => 'showByLine',
					  'showProductTitle' => 'showProductTitle',
					  'showProductPrice' => 'showProductPrice',
					  'useCaching' => 'useCaching',
					  'cacheLifetime' => 'cacheLifetime');
    $hidden_field_name = 'z_submit_hidden';


    $opt_val = get_option('zstore_options');


    if(isset($_POST[ $hidden_field_name ]) && $_POST[ $hidden_field_name ] == 'Y' ) {

		unset($opt_val);
		$opt_val = array();
		
		foreach($_POST['zstore_options'] as $key => $z_opts) {
				$opt_val[$key] = $z_opts;
		}
		
		update_option( 'zstore_options', $opt_val );



?>

<div id="message" class="updated fade">
  <p><strong>
    <?php _e('Options saved.', 'zstore_trans_domain' ); ?>
    </strong></p>
</div>

<?php
	}
?>
<div class="wrap">
<h2><?php _e( 'Zstore Helper', 'zstore_trans_domain' ); ?></h2>
<p>You can now get a special premium version of the ZStore Helper plugin. It contains some extra features that you may find worthy of a few dollars. Go to the <a href="http://www.wptheme4u.com/premium-zstore/download-prem-zstore/">Premium Zstore Plugin</a> store page to find out more.</p>
<?php
if(isset($_GET['wpzstore-page']) && $_GET['wpzstore-page'] == 'docs') {
	if( function_exists( 'is_multisite' ) && stristr(dirname(__FILE__), 'mu-plugins') !== FALSE ) {
		require_once('zstore-helper/zstore_docs.php'); //select the documentation.
	} else {
		require_once('zstore_docs.php');
	}
} else {
	if( function_exists( 'is_multisite' ) && stristr(dirname(__FILE__), 'mu-plugins') !== FALSE ) {
		require_once('zstore-helper/zstore_options.php'); //select the options entry page.
	} else {
		require_once('zstore_options.php'); //select the options entry page.
	}
}
?>
</div>
<?php

}

function zstore_add_css() {
	$site_root = get_option('siteurl');
	$pos = strpos(dirname(__FILE__), 'wp-content');
	$path = substr(dirname(__FILE__), $pos);
	$path = str_replace('\\', '/', $path);
	$string = '<link id="ext_css" rel="stylesheet" type="text/css" href="'.$site_root.'/'.$path.'/zstore/css/zstore.css" />'."\n";
	echo $string;
}

function zstore_helper_shortcode($atts) {
	
	if(isset($atts['producttype'])) {
			$atts['producttype'] = product_type_to_id($atts['producttype']);
	}

	$defaults = get_option('zstore_options');
	
	$d_keys = $defaults['keywords'];
	
	$args = shortcode_atts($defaults, $atts);
	
	$args_to_merge = camel_convertor($defaults, $atts);
	
	$args = array_merge($args, $args_to_merge);
	
	if(isset($_GET['keywords']) && !empty($_GET['keywords']))
		$args['keywords'] = $_GET['keywords'];
	
	foreach($args as $key => $arg) {
		
		$_GET[$key] = $arg;
		
	}

	//change directories to allow caching to work if cache is enabled.
	if($args['useCaching'] == 'true') {
		if(!is_dir('c')) {
			mkdir('c');
			chmod('c',0755);
			if(!is_dir('c')) {
				echo 'I could not create the \'c\' cache folder, sorry. Please either turn off caching or use FTP to create a folder called \'c\' in your WordPress directory, next to \'wp-content\' &amp; set write permissions(chmod) to 0755.';
				return false;
			}
		}
	}

	$plugin_info = pathinfo(__FILE__);
	$root_path_zstore = $plugin_info['dirname'].'/zstore/include/zstore.php';
	$root_path_strings = $plugin_info['dirname'].'/zstore/include/strings.php';

	ob_start(); //Start output buffering
	@include($root_path_strings);
	@include($root_path_zstore);
	$zstore_buff = ob_get_contents();
	ob_end_clean();
	
	if($args['useCaching'] == 'true') {
	
		$zstore_buff = preg_replace('/\<img src\="(.*)" class\="realviewImage" alt\="(.*)" title\="(.*)" style\="(.*)" (.*)\>/i', "<img src=\"".get_bloginfo('home')."/$1\" class=\"realviewImage\" alt=\"$2\" title=\"$3\" style=\"$4\" $5>", $zstore_buff);
	
	}
	
	$_GET['keywords'] = $d_keys;
	
	return $zstore_buff;

	
}

function camel_convertor($defaults, $atts) {
	
	$out = array();
	
	foreach($defaults as $key => $default) {
		
		$lkey = strtolower($key);
		if(isset($atts[$lkey])) {
			
			$out[$key] = $atts[$lkey];
			
		}
		
	}
	
	return $out;
	
}

function multi_array_search($s, $as, $pk = null) {

	if(!is_array($as))
		return false;
		
	foreach($as as $k => $a) {
		if(is_array($a)) {
			$v = multi_array_search($s, $a, $k);
			if($v !== null)
				return $v;
		} else {
			if($a == $s) {
				if(isset($pk) && $pk !== null)
					return $pk;
				else
					return $k;
			} else {
				continue;
			}
		}
	
	}
	
}

function product_type_to_id($p_name) {
		
	/*$prods = array('128' => 'bumper stickers', '137' => 'cards', '144' => 'mousepads',
				   '145' => 'buttons', '146' => 'keychains', '147' => 'magnets',
				   '148' => 'hats', '149' => 'bags', '151' => 'ties',
				   '153' => 'photo sculptures', '154' => 'aprons', '156' => 'photo prints',
				   '158' => 'calendars', '167' => 'keds shoes', '168' => 'mugs',
				   '172' => 'postage', '186' => 'skateboards', '217' => 'stickers',
				   '228' => 'posters', '231' => 'embroidered shirts', '232' => 'embroidered bags',
				   '233' => 'embroidered hats', '235' => 't-shirts', '239' => 'postcards',
				   '240' => 'profile cards', '127' => 'binders', '155' => 'pet apparel',
				   '161' => 'invitations', '199' => 'letterhead', '229' => 'stationery',
				   '244' => 'flyers', '245' => 'rackcards', '121' => 'envelopes',
				   '106' => 'labels', '175' => 'ornaments', '176' => 'ipad/iphone cases',
				   '174' => 'coasters', '177' => 'necklaces', '227' => 'tiles', '135' => 'premium gift boxes',
				   '246' => 'gift boxes', '179' => 'casemate cases', '130' => 'notebooks', '133' => 'notepads',
				   '116' => 'puzzles', '160' => 'premium magnets', '252' => 'photo plaques', '163' => 'cork coasters',
				   '115' => 'plates', '159' => 'gel mousepads', '124' => 'electronics bags');*/
				   
	$prods = array(
		'bagettes_bag' =>
			array('Bagettes Bag', '223'),
		'casemate_case' =>
			array('casemate cases', '179'),
		'caseable_case' =>
			array('Caseable Cases', '222'),
		'fuji_coaster' => 
			array('cork coasters', '163'),
		'fuji_electronicsbag' => 
			array('electronics bags', '124'),
		'fuji_fleximagnet' => 
			array('premium magnets', '160'), 	
		'fuji_mousepad' => 
			array('gel mousepads', '159'), 
		'fuji_notebook' => 
			array('notebooks', '130'),
		'fuji_notepad' => 
			array('notepads', '133'),
		'fuji_plaque' => 
			array('photo plaques', '252'),
		'fuji_plate' => 
			array('plates', '115'),
		'fuji_puzzle' =>
			array('puzzles', '116'),
		'libertybottle_bottle' =>
			array('water bottle', '126'),
		'mojo_kitchetowel' =>
			array('tea towels', '197'),
		'mojo_napkin' =>
			array('napkins', '185'),
		'mojo_placemat' =>
			array('placemats', '193'),
		'mojo_throwpillow' =>
			array('throw pillows', '189'),
		'musicskins_skin' =>
			array('custom skins', '134'),
		'planetjill_giftbox' => 
			array('premium gift boxes', '135'),
		'rickshaw_accessory' => 
			array('rickshaw accessory'),
		'rickshaw_flapsleeve' => 
			array('rickshaw flap sleeve', '204'),
		'rickshaw_folio' => 
			array('rickshaw folio', '201'),
		'rickshaw_messengerbag' => 
			array('rickshaw messenger bag', '210'),
		'rickshaw_sleeve' => 
			array('rickshaw sleeve', '205'),
		'zazzle_apron' => 
			array('aprons', '154'),
		'zazzle_bag' =>
			array('bags', '149'), 
		'zazzle_binder' =>
			array('binders', '127'),	
		'zazzle_bumpersticker' => 
			array('bumper stickers', '128'),
		'zazzle_button' => 
			array('buttons', '145'),
		'zazzle_calendar' => 
			array('calendars', '158'),
		'zazzle_candyjar' => 
			array('candy jar', '165'),
		'zazzle_card' => 
			array('cards', '137'),
		'zazzle_coaster' => 
			array('coasters', '174'),
		'zazzle_doodle' => 
			array('doodle speaker', '166'),
		'zazzle_embroideredbag' =>
			array('embroidered bags', '232'),
		'zazzle_embroideredhat' => 
			array('embroidered hats', '233'),
		'zazzle_embroideredshirt' =>
			array('embroidered shirts', '231'),
		'zazzle_envelope' => 
			array('envelopes', '121'),
		'zazzle_flyer' => 
			array('flyers', '244'),
		'zazzle_giftbox' => 
			array('gift boxes', '246'),
		'zazzle_hat' => 
			array('hats', '148'),	
		'zazzle_invitation' => 
			array('invitations', '161'),
		'zazzle_keds' => 
			array('keds shoes', '167'),
		'zazzle_keychain' =>
			array('keychains', '146'),
		'zazzle_label' => 
			array('labels', '106'),
		'zazzle_letterhead' => 
			array('letterhead', '199'),
		'zazzle_magnet' => 
			array('magnets', '147'),
		'zazzle_mousepad' => 
			array('mousepads', '144'),
		'zazzle_mug' => 
			array('mugs', '168'),
		'zazzle_necklace' =>
			array('necklaces', '177'),
		'zazzle_ornament' => 
			array('ornaments', '175'),
		'zazzle_petbowl' => 
			array('pet bowl', '215'),
		'zazzle_petshirt' => 
			array('pet apparel', '155'),
		'zazzle_photocard' => 
			array('photo cards', '243'),
		'zazzle_photoenlargement' => 
			array('photo enlargements', '190'),
		'zazzle_photoprint' =>
			array('photo prints', '156'),
		'zazzle_photosculpture' => 
			array('photo sculptures', '153'),
		'zazzle_pitcher' => 
			array('pitcher', '104'),	
		'zazzle_postcard' =>
			array('postcards', '239'),
		'zazzle_poster' => 
			array('posters', '228'),
		'zazzle_print' =>
			array('prints', '228'),
		'zazzle_profilecard' => 
			array('profile cards', '240'),
		'zazzle_rackcard' => 
			array('rackcards', '245'),
		'zazzle_screenprintshirt' => 
			array('screen print shirts'),
		'zazzle_shirt' =>
			array('t-shirts', '235'),
		'zazzle_skateboard' => 
			array('skateboards', '186'),
		'zazzle_specialitymug' => 
			array('speciality mugs', '183'),
		'zazzle_speckcase' => 
			array('ipad/iphone cases', '176'),
		'zazzle_stamp' =>
			array('postage', '172'),
		'zazzle_stationery' => 
			array('stationery', '229'),
		'zazzle_sticker' => 
			array('stickers', '217'),
		'zazzle_teapot' => 
			array('teapots', '180'),
		'zazzle_tie' => 
			array('ties', '151'),
		'zazzle_tile' => 
			array('tiles', '227'),
		'zazzle_tileholder' => 
			array('tile holders'),
		'zazzle_wrappedcanvas' => 
			array('wrapped canvas', '192')
		);
	
	$p_name = strtolower($p_name);
	
	$p_num = multi_array_search($p_name, $prods);
	
	if($p_num === false || $p_num === null) {
		if(array_key_exists($p_name, $prods))
			return $p_name;
		else
			return '';
	}
	
	return $p_num;
	
}

if(get_bloginfo('version') >= '2.8') {

	class ZazzleSearchWidget extends WP_Widget {
	 
		function ZazzleSearchWidget() {
			parent::WP_Widget(false, $name = 'Zazzle Store Search');    
		}
	 
		function widget($args, $instance) {        
			extract( $args );
			$title = $instance['title']; 
			$zazzleStoreURL = $instance['zazzleStoreURL'];
			?>
				  <?php echo $before_widget; ?>
					  <?php echo $before_title . $title . $after_title; ?>
	 
						  <form action="<?php echo $zazzleStoreURL; ?>" method="get" name="ZazzleSearch" enctype="application/x-www-form-urlencoded">
							<input type="text" name="keywords" value="<?php if(isset($_GET['keywords']) && !empty($_GET['keywords'])) echo $_GET['keywords']; ?>" />
							<input type="submit" value="Search" />
						  </form>
	 
				  <?php echo $after_widget; ?>
			<?php
	
		}
	 
	
		function update($new_instance, $old_instance) {                
			return $new_instance;
		}
	 
		function form($instance) {                
			$title = esc_attr($instance['title']);
			$zazzleStoreURL = esc_attr($instance['zazzleStoreURL']);
			?>
				<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
				<p><label for="<?php echo $this->get_field_id('zazzleStoreURL'); ?>"><?php _e('URL to page with zazzle store<br /><small>(use full URL including http://)</small>:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('zazzleStoreURL'); ?>" name="<?php echo $this->get_field_name('zazzleStoreURL'); ?>" type="text" value="<?php echo $zazzleStoreURL; ?>" /></label></p>
			<?php 
	
		}
	}
	
	add_action('widgets_init', create_function('', 'return register_widget("ZazzleSearchWidget");'));

}

?>