<p><a href="<?php echo preg_replace('/&wpzstore-page=[^&]*/', '', $_SERVER['REQUEST_URI']); ?>">&laquo; Back to options page</a></p>
<h3>Goal</h3>
<p>This goal of this plugin is simple. It makes using the Zazzle Store builder (known as zstore) easier to use in a WordPress enviroment. Setting it up without the help of this plugin can sometimes take numerous hacks &amp; a few hours of work and for the inexperienced coder it is nearly impossible.</p>
<h3>What It Does</h3>
<p>After enabling in the WordPress plugin page you can start using it straight away. No moving files, nothing like that. All you need to do is go into the options page (Settings -&gt; Zstore Helper) &amp; fill in your Contributor Handle (Zazzle Username) &amp; your ready to use it.</p>
<h3>Installing &amp; Using</h3>
<p>Here is a step by step of how to install &amp; start using the Zstore Helper.</p>
<ol>
	<li>Download the plugin (can be found <a href="http://return-true.com/2009/03/ZStore-Helper-WordPress-Plugin-For-Zazzle-Store-Builder#download">here</a>.)</li>
	<li>Download the Zazzle Store Builder from <a href="http://zazzle.com/sell/tools/storebuilder">here</a>.</li>
	<li>Unzip the contents of the plugin (<code>zstore-helper.zip</code>) to the <code>wp-content/plugins</code> folder in your WP installation.</li>
	<li>Go to <code>wp-content/plugins/zstore-helper/zstore</code> which should be empty. Open the Zazzle Store Builder zip file. Go into the folder you can see &amp; drag out the includes &amp; css folders into the zstore folder. See <a href="http://return-true.com/2009/03/ZStore-Helper-WordPress-Plugin-For-Zazzle-Store-Builder">figure 1</a> for what your directory should look like.</li>
	<li>Now go into your WordPress admin. Head to the plugins section &amp; turn on the Zstore Helper plugin. Next head to the Zstore Helper options page that will appear under Settings &amp; set some global options. These are the options that will always be run, unless you over ride them (more on that later).</li>
	<li>Once you've set the global options all you need to do is make a page or post &amp; put <code>[zstore]</code> into it. Publish &amp; your store will appear. :)</li>
    <li>You may over-ride any option set in the options page using attributes in the Shortcode. Like <code>[zstore contributorhandle="otherzazzlestore"]</code>. A list of these is available further down this page.</li>
</ol>
<h3>New Search Widget</h3>
<p>After a few requests I have added a widget that will allow you to search the Zazzle store placed on your wordpress blog. To use it you must have a single post or page with the store builder already set up. By that I mean 1 page with a fixed URL. For example, a page called 'Zazzle Store' with a URL of 'http://example.com/zazzle-store/'. When that's done go to the widgets section add the Zazzle Store Search to your sidebar &amp; fill in the Title &amp; the FULL URL to the page with your Zazzle store on, including 'http://'. <strong>Note:</strong> The search will only search the results of the settings you have set in the Zstore options page.</p>
<p>The reason it has to be done on a page or single post is due to coding limitations since the Zazzle Store Builders license does not allow me to edit it. All of the current code works by augmenting the code &amp; not altering the original in any way. I will keep trying to improve the search over time.</p>
<h3>Options</h3>
<p>Here is a list of the options available on the options page &amp; detailed instructions on what they do:</p>
<dl>
	<dt><strong>Contributor Handle</strong></dt>
    <dd>The Zazzle username associated with the store you wish to show products from.</dd>
    <dt><strong>Associate ID</strong></dt>
    <dd>An ID used for referrals. Found under the associates center, which can be found in the gallery tab of MyZazzle.</dd>
    <dt><strong>Product Line ID</strong></dt>
    <dd>Allows you to display a specific product line. Leave blank to show all proucts from a gallery. The product line ID can be found by clicking on a product line in a gallery. The URL will look something like <code>http://www.zazzle.com/coatsofarms/products/cg-196595220567583981</code>. The string or numbers on the end is the product line ID.</dd>
    <dt><strong>Product Type</strong></dt>
    <dd>Exactly what it says. Restrict which type of product is show from the gallery.</dd>
    <dt><strong>Keywords</strong></dt>
    <dd>Also exactly what it says. Restict products returned from the gallery by a keyword. Comma seperated. Eg. Cat, star, cow. You get the idea.</dd>
    <dt><strong>Grid Width</strong></dt>
    <dd>How wide, in pixels, should the complete product grid be. Although this is in pixels you do not need the px on the end, just the number.</dd>
    <dt><strong>Grid Cell Size</strong></dt>
    <dd>The size of each grid cell. Just pick a size from the list.</dd>
    <dt><strong>Grid Cell Spacing</strong></dt>
    <dd>The space, again in pixels, between each grid cell. As before although the value is in pixels only the number is needed &amp; not px.</dd>
    <dt><strong>Grid Cell Background Color</strong></dt>
    <dd>The color used for each grid cells background color. In HEX but without the hash(#). Eg. FFFFFF is white. For a list of HEX colors try this <a href="http://cloford.com/resources/colours/500col.htm">link</a>. You want the 6 char string under the column 'Hex'.</dd>
    <dt><strong>Use Google Analytics</strong></dt>
    <dd>If you want to use Google Analytics the set this to true &amp; then fill in Google Analytics Number with your UA number from your Google Analytics account. If you already have a Google Analytics plugin running on WordPress you probably won't need this.</dd>
    <dt><strong>Google Analytics Number (ID)</strong></dt>
    <dd>If you set the last option to true then this is where you put your Google Analytics Number. It looks like this: UA-xxxxxxx-x. If you already have a Google Analytics plugin running on WordPress you probably won't need this.</dd>
    <dt><strong>Show How Many Products</strong></dt>
    <dd>How many products do you want to show per page, or if you have pagination turned off, how many do you want to show in total. Default is 20. It is generally <strong>not</strong> a good idea to set this above 100 or 150 as it could crash older computers while trying to load all the images.</dd>
    <dt><strong>Starting Page</strong></dt>
    <dd>What page of results do you want to start on.</dd>
    <dt><strong>Show Pagination</strong></dt>
    <dd>Do you want to show a pagination. A pagination is the list of numbers that represent links to other pages if there are too many products to show on the first page.</dd>
    <dt><strong>Show Sorting</strong></dt>
    <dd>Do you want to show the sorting options. This allows visitors to sort by the Date Created or Popularity if set to true.</dd>
    <dt><strong>Default Sorting</strong></dt>
    <dd>What do you want the products to be sorted by. Applies even if Show Sorting is set to false.</dd>
    <dt><strong>Show 'By' Line</strong></dt>
    <dd>Do you want to show the products 'By' line. This is the line that says 'by zazzlestore'. Another words do you want to show which store created to product.</dd>
    <dt><strong>Show Product Title</strong></dt>
    <dd>Pretty obvious. Do you want to show the products title.</dd>
    <dt><strong>Show Product Price</strong></dt>
    <dd>Again obvious. Do you want to show the products price.</dd>
    <dt><strong>Enable Caching</strong></dt>
    <dd>Do you want to enable caching. This helps reduce server load for both you and Zazzle since it saves the images it uses so it doesn't have to contact Zazzle everytime. Handy if you get a lot of visitors.</dd>
    <dt><strong>Chache Lifetime</strong></dt>
    <dd>How long before the cache is deleted &amp; a new set of images is retrieved from Zazzle. This is in seconds. (3600 seconds = 1 hour)</dd>
</dl>
<h3>Shortcode Over-rides</h3>
<p>Here is a list, with examples, of the attributes used for over-rides. They are similar to HTML attributes so HTML users should feel right at home. Their uses match the options above so refer to the list above for any explinations.</p>
<dl>
	<dt><strong><em>contributorhandle</em></strong></dt>
    <dd>Example: <code>[zstore contributorhandle="ZazzleStore"]</code></dd>
    <dt><strong><em>associateid</em></strong></dt>
    <dd>Example: <code>[zstore associateid="THEASSOCIATEID"]</code></dd>
    <dt><strong><em>productlineid</em></strong></dt>
    <dd>Example: <code>[zstore productlineid="THEPRODUCTLINEID"]</code></dd>
    <dt><strong><em>producttype</em></strong></dt>
    <dd>Example: <code>[zstore producttype="cards"]</code>. You may use the three digit code or the name of a product from <a href="#pro-type-list">this</a> list.</dd>
    <dt><strong><em>keywords</em></strong></dt>
    <dd>Example: <code>[zstore keywords="cats"]</code>. A list of keywords if more than one is used they must be comma(,) seperated.</dd>
    <dt><strong><em>gridwidth</em></strong></dt>
    <dd>Example: <code>[zstore gridwidth="400"]</code></dd>
    <dt><strong><em>gridcellsize</em></strong></dt>
    <dd>Example: <code>[zstore gridcellsize="medium"]</code>. This must match either tiny, small, medium, large or huge.</dd>
    <dt><strong><em>gridcellspacing</em></strong></dt>
    <dd>Example: <code>[zstore gridcellspacing="5"]</code></dd>
    <dt><strong><em>gridcellbgcolor</em></strong></dt>
    <dd>Example: <code>[zstore gridcellbgcolor="FFFFFF"]</code></dd>
    <dt><strong><em>useanalytics</em></strong></dt>
    <dd>Example: <code>[zstore useanalytics="false"]</code>. Options are true or false.</dd>
    <dt><strong><em>analyticsid</em></strong></dt>
    <dd>Example: <code>[zstore analyticsid="UA-xxxxxxx-x"]</code></dd>
    <dt><strong><em>showhowmany</em></strong></dt>
    <dd>Example: <code>[zstore showhowmany="20"]</code></dd>
    <dt><strong><em>startpage</em></strong></dt>
    <dd>Example: <code>[zstore startpage="1"]</code></dd>
    <dt><strong><em>showpagination</em></strong></dt>
    <dd>Example: <code>[zstore showpagination="true"]</code>. Options are true or false.</dd>
    <dt><strong><em>showsorting</em></strong></dt>
    <dd>Example: <code>[zstore showsorting="true"]</code>. Options are true or false</dd>
    <dt><strong><em>defaultsort</em></strong></dt>
    <dd>Example: <code>[zstore defaultsort="date_created"]</code>. Options are date_created or popularity.</dd>
    <dt><strong><em>showproductdescription</em></strong></dt>
    <dd>Example: <code>[zstore showproductdescription="true"]</code>. Options are true or false.</dd>
    <dt><strong><em>showbyline</em></strong></dt>
    <dd>Example: <code>[zstore showbyline="ZazzleStore"]</code>. Options are true or false.</dd>
    <dt><strong><em>showproducttitle</em></strong></dt>
    <dd>Example: <code>[zstore showproducttitle="true"]</code>. Options are true or false.</dd>
    <dt><strong><em>showproductprice</em></strong></dt>
    <dd>Example: <code>[zstore showproductprice="true"]</code>. Options are true or false.</dd>
    <dt><strong><em>usecaching</em></strong></dt>
    <dd>Example: <code>[zstore usecaching="false"]</code>. Options are true or false</dd>
    <dt><strong><em>cachelifetime</em></strong></dt>
    <dd>Example: <code>[zstore cachelifetime="3600"]</code>. Length in seconds.</dd>
</dl>
<p>You can use any of these in combination like this: <code>[zstore contributorhandle="ZazzleStore" producttype="Mugs" keywords="cats, dogs"]</code>.</p>
<h3>Product Type List</h3><a name="pro-type-list"></a>
<p>This is the list of product types for use with the <code>producttype</code> Shortcode attribute. They are the same as those listed in the drop down box on the options page, this list is here just for reference. Also they are case-insensitive. Due to the change from numbers to strings this list has changed. Please use the string at the front of the list in the shortcode to pull back the product you are looking for.
<ul>
				<li>zazzle_apron - Aprons</li>
				<li>bagettes_bag - Bagettes Bags</li>
				<li>zazzle_bag - Bags</li>
				<li>zazzle_binder - Binders</li>
				<li>zazzle_bumpersticker - Bumper Stickers</li>
				<li>zazzle_button - Buttons</li>
				<li>zazzle_calendar - Calendars</li>
				<li>zazzle_card - Cards</li>
				<li>zazzle_candyjar - Candy Jar</li>
				<li>caseable_case - Caseable Cases</li>
				<li>casemate_case - Casemate Cases</li>
				<li>zazzle_coaster - Coasters</li>
				<li>fuji_coaster - Cork Coasters</li>
				<li>musicskins_skin - Custom Skins</li>
				<li>zazzle_doodle - Doodle Speaker</li>
				<li>fuji_electronicsbag - Electronics Bags</li>
				<li>zazzle_embroideredbag - Embroidered Bags</li>
				<li>zazzle_embroideredhat - Embroidered Hats</li>
				<li>zazzle_embroideredshirt - Embroidered Shirts</li>
				<li>zazzle_envelope - Envelopes</li>
				<li>zazzle_flyer - Flyers</li>
				<li>fuji_mousepad - Gel Mousepads</li>
				<li>zazzle_giftbox - Gift Boxes</li>
				<li>zazzle_hat - Hats</li>
				<li>zazzle_invitation - Invitations</li>
				<li>zazzle_speckcase - iPad/iPhone Cases</li>
				<li>zazzle_keychain - Keychains</li>
				<li>mojo_kitchentowel - Kitchen Towels</li>
				<li>zazzle_label - Labels</li>
				<li>zazzle_letterhead - Letterhead</li>
				<li>zazzle_magnet - Magnets</li>
				<li>zazzle_mousepad - Mousepads</li>
				<li>zazzle_mug - Mugs</li>
				<li>mojo_napkin - Napkins</li>
				<li>zazzle_necklace - Necklaces</li>
				<li>fuji_notebook - Notebooks</li>
				<li>fuji_notepad - Notepads</li>
				<li>zazzle_ornament - Ornaments</li>
				<li>zazzle_petshirt - Pet Apparel</li>
				<li>zazzle_petbowl - Pet Bowl</li>
				<li>zazzle_photocard - Photo Cards</li>
				<li>zazzle_photoenlargement - Photo Enlargement</li>
				<li>fuji_plaque - Photo Plaques</li>
				<li>zazzle_photoprint - Photo Prints</li>
				<li>zazzle_photosculpture - Photo Sculptures</li>
				<li>zazzle_pitcher - Pitcher</li>
				<li>mojo_placemat - Placemats</li>
				<li>fuji_plate" - Plates</li>
				<li>zazzle_stamp - Postage</li>
				<li>zazzle_postcard - Postcards</li>
				<li>zazzle_print - Poster Prints</li>
				<li>planetjill_giftbox - Premium Gift Boxes</li>
				<li>fuji_fleximagnet - Premium Magnets</li>
				<li>zazzle_profilecard - Profile Cards</li>
				<li>fuji_puzzle - Puzzles</li>
				<li>zazzle_rackcard - Rackcards</li>
				<li>rickshaw_flapsleeve - Rickshaw Flap Sleeves</li>
				<li>rickshaw_folio - Rickshaw Folio</li>
				<li>rickshaw_messengerbag - Rickshaw Messenger Bag</li>
				<li>rickshaw_sleeve - Rickshaw Sleeve</li>
				<li>zazzle_skateboard - Skateboards</li>
				<li>zazzle_specialitymug - Speciality Mugs</li>
				<li>zazzle_stationery - Stationary</li>
				<li>zazzle_sticker - Stickers</li>
				<li>zazzle_teapot - Teapots</li>
				<li>zazzle_tie - Ties</li>
				<li>zazzle_tile - Tiles</li>
				<li>mojo_throwpillow - Throw Pillows</li>
				<li>zazzle_shirt - T-Shirts</li>
				<li>libertybottle_bottle - Water Bottles</li>
				<li>zazzle_wrappedcanvas - Wrapped Canvas</li>
		</ul>